diff --git a/src/backend/optimizer/path/joinrels.c b/src/backend/optimizer/path/joinrels.c
new file mode 100644
index 5a68de3..ea24ed9
*** a/src/backend/optimizer/path/joinrels.c
--- b/src/backend/optimizer/path/joinrels.c
***************
*** 14,23 ****
--- 14,29 ----
   */
  #include "postgres.h"
  
+ #include "miscadmin.h"
+ #include "nodes/relation.h"
+ #include "optimizer/clauses.h"
  #include "optimizer/joininfo.h"
  #include "optimizer/pathnode.h"
  #include "optimizer/paths.h"
+ #include "optimizer/prep.h"
+ #include "optimizer/cost.h"
  #include "utils/memutils.h"
+ #include "utils/lsyscache.h"
  
  
  static void make_rels_by_clause_joins(PlannerInfo *root,
*************** static void make_rels_by_clauseless_join
*** 29,40 ****
  static bool has_join_restriction(PlannerInfo *root, RelOptInfo *rel);
  static bool has_legal_joinclause(PlannerInfo *root, RelOptInfo *rel);
  static bool is_dummy_rel(RelOptInfo *rel);
- static void mark_dummy_rel(RelOptInfo *rel);
  static bool restriction_is_constant_false(List *restrictlist,
  							  bool only_pushed_down);
  static void populate_joinrel_with_paths(PlannerInfo *root, RelOptInfo *rel1,
  							RelOptInfo *rel2, RelOptInfo *joinrel,
  							SpecialJoinInfo *sjinfo, List *restrictlist);
  
  
  /*
--- 35,53 ----
  static bool has_join_restriction(PlannerInfo *root, RelOptInfo *rel);
  static bool has_legal_joinclause(PlannerInfo *root, RelOptInfo *rel);
  static bool is_dummy_rel(RelOptInfo *rel);
  static bool restriction_is_constant_false(List *restrictlist,
  							  bool only_pushed_down);
  static void populate_joinrel_with_paths(PlannerInfo *root, RelOptInfo *rel1,
  							RelOptInfo *rel2, RelOptInfo *joinrel,
  							SpecialJoinInfo *sjinfo, List *restrictlist);
+ static void try_partition_wise_join(PlannerInfo *root, RelOptInfo *rel1,
+ 						  RelOptInfo *rel2, RelOptInfo *joinrel,
+ 						  SpecialJoinInfo *parent_sjinfo,
+ 						  List *parent_restrictlist);
+ static int match_expr_to_partition_keys(Expr *expr, RelOptInfo *rel);
+ static void build_joinrel_partition_bounds(RelOptInfo *rel1, RelOptInfo *rel2,
+ 							   RelOptInfo *joinrel, JoinType jointype,
+ 							   List **rel1_parts, List **rel2_parts);
  
  
  /*
*************** make_join_rel(PlannerInfo *root, RelOptI
*** 731,736 ****
--- 744,752 ----
  	populate_joinrel_with_paths(root, rel1, rel2, joinrel, sjinfo,
  								restrictlist);
  
+ 	/* Apply partition-wise join technique, if possible. */
+ 	try_partition_wise_join(root, rel1, rel2, joinrel, sjinfo, restrictlist);
+ 
  	bms_free(joinrelids);
  
  	return joinrel;
*************** is_dummy_rel(RelOptInfo *rel)
*** 1197,1203 ****
   * is that the best solution is to explicitly make the dummy path in the same
   * context the given RelOptInfo is in.
   */
! static void
  mark_dummy_rel(RelOptInfo *rel)
  {
  	MemoryContext oldcontext;
--- 1213,1219 ----
   * is that the best solution is to explicitly make the dummy path in the same
   * context the given RelOptInfo is in.
   */
! void
  mark_dummy_rel(RelOptInfo *rel)
  {
  	MemoryContext oldcontext;
*************** mark_dummy_rel(RelOptInfo *rel)
*** 1217,1223 ****
  	rel->partial_pathlist = NIL;
  
  	/* Set up the dummy path */
! 	add_path(rel, (Path *) create_append_path(rel, NIL, NULL, 0, NIL));
  
  	/* Set or update cheapest_total_path and related fields */
  	set_cheapest(rel);
--- 1233,1239 ----
  	rel->partial_pathlist = NIL;
  
  	/* Set up the dummy path */
! 	add_path(rel, (Path *) create_append_path(rel, NIL, NULL, 0, NIL), false);
  
  	/* Set or update cheapest_total_path and related fields */
  	set_cheapest(rel);
*************** restriction_is_constant_false(List *rest
*** 1268,1270 ****
--- 1284,1712 ----
  	}
  	return false;
  }
+ 
+ /*
+  * Assess whether join between given two partitioned relations can be broken
+  * down into joins between matching partitions; a technique called
+  * "partition-wise join"
+  *
+  * Partition-wise join is possible when a. Joining relations have same
+  * partitioning scheme b. There exists an equi-join between the partition keys
+  * of the two relations.
+  *
+  * Partition-wise join is planned as follows (details: optimizer/README.)
+  *
+  * 1. Create the RelOptInfos for joins between matching partitions i.e
+  * child-joins and add paths those.
+  *
+  * 2. Add "append" paths to join between parent relations. The second phase is
+  * implemented by generate_partition_wise_join_paths().
+  *
+  * The RelOptInfo, SpecialJoinInfo and restrictlist for each child join are
+  * obtained by translating the respective parent join structures.
+  */
+ static void
+ try_partition_wise_join(PlannerInfo *root, RelOptInfo *rel1, RelOptInfo *rel2,
+ 						RelOptInfo *joinrel, SpecialJoinInfo *parent_sjinfo,
+ 						List *parent_restrictlist)
+ {
+ 	int			nparts;
+ 	int			cnt_parts;
+ 	ListCell   *lc1;
+ 	ListCell   *lc2;
+ 	List	   *rel1_parts;
+ 	List	   *rel2_parts;
+ 	bool		is_strict;
+ 
+ 	/* Guard against stack overflow due to overly deep partition hierarchy. */
+ 	check_stack_depth();
+ 
+ 	/* Nothing to do, if the join relation is not partitioned. */
+ 	if (!joinrel->part_scheme)
+ 		return;
+ 
+ 	/*
+ 	 * set_append_rel_pathlist() may not create paths in children of an empty
+ 	 * partitioned table and so we can not add paths to a child-joins when one
+ 	 * of the joining relations is empty. So, deem such a join as
+ 	 * unpartitioned.
+ 	 */
+ 	if (IS_DUMMY_REL(rel1) || IS_DUMMY_REL(rel2))
+ 		return;
+ 
+ 	/*
+ 	 * Since this join relation is partitioned, all the base relations
+ 	 * participating in this join must be partitioned and so are all the
+ 	 * intermediate join relations.
+ 	 */
+ 	Assert(rel1->part_scheme && rel2->part_scheme);
+ 
+ 	/*
+ 	 * Every pair of joining relations we see here should have an equi-join
+ 	 * between partition keys if this join has been deemed as a partitioned
+ 	 * join. See build_joinrel_partition_info() for reasons.
+ 	 */
+ 	Assert(have_partkey_equi_join(rel1, rel2, parent_sjinfo->jointype,
+ 								  parent_restrictlist, &is_strict));
+ 
+ 	/*
+ 	 * The partition scheme of the join relation should match that of the
+ 	 * joining relations.
+ 	 */
+ 	Assert(joinrel->part_scheme == rel1->part_scheme &&
+ 		   joinrel->part_scheme == rel2->part_scheme);
+ 
+ 	/* We should have RelOptInfos of the partitions available. */
+ 	Assert(rel1->part_rels && rel2->part_rels);
+ 
+ 	/*
+ 	 * Calculate bounds for the join relation. If we can not come up with joint
+ 	 * bounds, we can not use partition-wise join.
+ 	 */
+ 	build_joinrel_partition_bounds(rel1, rel2, joinrel,
+ 								   parent_sjinfo->jointype, &rel1_parts,
+ 								   &rel2_parts);
+ 	if (!joinrel->boundinfo)
+ 		return;
+ 
+ 	Assert(list_length(rel1_parts) == list_length(rel2_parts));
+ 	Assert(joinrel->nparts == list_length(rel1_parts));
+ 	Assert(joinrel->nparts > 0);
+ 
+ 	nparts = joinrel->nparts;
+ 
+ 	elog(DEBUG3, "join between relations %s and %s is considered for partition-wise join.",
+ 		 bmsToString(rel1->relids), bmsToString(rel2->relids));
+ 
+ 	/* Allocate space for hold child-joins RelOptInfos, if not already done. */
+ 	if (!joinrel->part_rels)
+ 		joinrel->part_rels = (RelOptInfo **) palloc0(sizeof(RelOptInfo *) * nparts);
+ 
+ 	/*
+ 	 * Create child join relations for this partitioned join, if those don't
+ 	 * exist. Add paths to child-joins for a pair of child relations
+ 	 * corresponding corresponding to the given pair of parent relations.
+ 	 */
+ 	cnt_parts = 0;
+ 	forboth (lc1, rel1_parts, lc2, rel2_parts)
+ 	{
+ 		RelOptInfo *child_rel1 = lfirst(lc1);
+ 		RelOptInfo *child_rel2 = lfirst(lc2);
+ 		SpecialJoinInfo	*child_sjinfo;
+ 		List   *child_restrictlist;
+ 		RelOptInfo *child_joinrel;
+ 		Relids	child_joinrelids;
+ 		AppendRelInfo **appinfos;
+ 		int		nappinfos;
+ 
+ 		/* We should never try to join two overlapping sets of rels. */
+ 		Assert(!bms_overlap(child_rel1->relids, child_rel2->relids));
+ 		child_joinrelids = bms_union(child_rel1->relids, child_rel2->relids);
+ 		appinfos = find_appinfos_by_relids(root, child_joinrelids, &nappinfos);
+ 
+ 		/*
+ 		 * Construct SpecialJoinInfo from parent join relations's
+ 		 * SpecialJoinInfo.
+ 		 */
+ 		child_sjinfo = build_child_join_sjinfo(root, parent_sjinfo,
+ 											   child_rel1->relids,
+ 											   child_rel2->relids);
+ 
+ 		/*
+ 		 * Construct restrictions applicable to the child join from
+ 		 * those applicable to the parent join.
+ 		 */
+ 		child_restrictlist = (List *) adjust_appendrel_attrs(root,
+ 												  (Node *) parent_restrictlist,
+ 														  nappinfos, appinfos);
+ 
+ 		child_joinrel = joinrel->part_rels[cnt_parts];
+ 		if (!child_joinrel)
+ 		{
+ 			child_joinrel = build_child_join_rel(root, child_rel1, child_rel2,
+ 												 joinrel, child_restrictlist,
+ 												 child_sjinfo,
+ 												 child_sjinfo->jointype);
+ 			joinrel->part_rels[cnt_parts] = child_joinrel;
+ 		}
+ 
+ 		Assert(bms_equal(child_joinrel->relids, child_joinrelids));
+ 
+ 		/* Also translate expressions that AggPath will use in its target. */
+ 		if (child_joinrel->gpi != NULL)
+ 		{
+ 			Assert(child_joinrel->gpi->target != NULL);
+ 
+ 			child_joinrel->gpi->target->exprs =
+ 				(List *) adjust_appendrel_attrs(root,
+ 												(Node *) child_joinrel->gpi->target->exprs,
+ 												nappinfos, appinfos);
+ 		}
+ 
+ 		populate_joinrel_with_paths(root, child_rel1, child_rel2,
+ 									child_joinrel, child_sjinfo,
+ 									child_restrictlist);
+ 
+ 		pfree(appinfos);
+ 
+ 		/*
+ 		 * If the child relations themselves are partitioned, try partition-wise join
+ 		 * recursively.
+ 		 */
+ 		try_partition_wise_join(root, child_rel1, child_rel2, child_joinrel,
+ 								child_sjinfo, child_restrictlist);
+ 		cnt_parts++;
+ 	}
+ }
+ 
+ /*
+  * Returns true if there exists an equi-join condition for each pair of
+  * partition key from given relations being joined.
+  */
+ bool
+ have_partkey_equi_join(RelOptInfo *rel1, RelOptInfo *rel2, JoinType jointype,
+ 					   List *restrictlist, bool *is_strict)
+ {
+ 	PartitionScheme	part_scheme = rel1->part_scheme;
+ 	ListCell	*lc;
+ 	int		cnt_pks;
+ 	int		num_pks;
+ 	bool   *pk_has_clause;
+ 
+ 	*is_strict = false;
+ 
+ 	/*
+ 	 * This function should be called when the joining relations have same
+ 	 * partitioning scheme.
+ 	 */
+ 	Assert(rel1->part_scheme == rel2->part_scheme);
+ 	Assert(part_scheme);
+ 
+ 	num_pks = part_scheme->partnatts;
+ 
+ 	pk_has_clause = (bool *) palloc0(sizeof(bool) * num_pks);
+ 
+ 	foreach (lc, restrictlist)
+ 	{
+ 		RestrictInfo *rinfo = lfirst(lc);
+ 		OpExpr		 *opexpr;
+ 		Expr		 *expr1;
+ 		Expr		 *expr2;
+ 		int		ipk1;
+ 		int		ipk2;
+ 
+ 		/* If processing an outer join, only use its own join clauses. */
+ 		if (IS_OUTER_JOIN(jointype) && rinfo->is_pushed_down)
+ 			continue;
+ 
+ 		/* Skip clauses which can not be used for a join. */
+ 		if (!rinfo->can_join)
+ 			continue;
+ 
+ 		/* Skip clauses which are not equality conditions. */
+ 		if (!rinfo->mergeopfamilies)
+ 			continue;
+ 
+ 		opexpr = (OpExpr *) rinfo->clause;
+ 		Assert(is_opclause(opexpr));
+ 
+ 		/*
+ 		 * The equi-join between partition keys is strict if equi-join between
+ 		 * at least one partition key is using a strict operator. See
+ 		 * explanation about outer join reordering identity 3 in
+ 		 * optimizer/README
+ 		 */
+ 		*is_strict = *is_strict || op_strict(opexpr->opno);
+ 
+ 		/* Match the operands to the relation. */
+ 		if (bms_is_subset(rinfo->left_relids, rel1->relids) &&
+ 			bms_is_subset(rinfo->right_relids, rel2->relids))
+ 		{
+ 			expr1 = linitial(opexpr->args);
+ 			expr2 = lsecond(opexpr->args);
+ 		}
+ 		else if (bms_is_subset(rinfo->left_relids, rel2->relids) &&
+ 				 bms_is_subset(rinfo->right_relids, rel1->relids))
+ 		{
+ 			expr1 = lsecond(opexpr->args);
+ 			expr2 = linitial(opexpr->args);
+ 		}
+ 		else
+ 			continue;
+ 
+ 		/*
+ 		 * Only clauses referencing the partition keys are useful for
+ 		 * partition-wise join.
+ 		 */
+ 		ipk1 = match_expr_to_partition_keys(expr1, rel1);
+ 		if (ipk1 < 0)
+ 			continue;
+ 		ipk2 = match_expr_to_partition_keys(expr2, rel2);
+ 		if (ipk2 < 0)
+ 			continue;
+ 
+ 		/*
+ 		 * If the clause refers to keys at different cardinal positions in the
+ 		 * partition keys of joining relations, it can not be used for
+ 		 * partition-wise join.
+ 		 */
+ 		if (ipk1 != ipk2)
+ 			continue;
+ 
+ 		/*
+ 		 * The clause allows partition-wise join if only it uses the same
+ 		 * operator family as that specified by the partition key.
+ 		 */
+ 		if (!list_member_oid(rinfo->mergeopfamilies,
+ 							 part_scheme->partopfamily[ipk1]))
+ 			continue;
+ 
+ 		/* Mark the partition key as having an equi-join clause. */
+ 		pk_has_clause[ipk1] = true;
+ 	}
+ 
+ 	/* Check whether every partition key has an equi-join condition. */
+ 	for (cnt_pks = 0; cnt_pks < num_pks; cnt_pks++)
+ 	{
+ 		if (!pk_has_clause[cnt_pks])
+ 		{
+ 			pfree(pk_has_clause);
+ 			return false;
+ 		}
+ 	}
+ 
+ 	pfree(pk_has_clause);
+ 	return true;
+ }
+ 
+ /*
+  * Find the partition key from the given relation matching the given
+  * expression. If found, return the index of the partition key, else return -1.
+  */
+ static int
+ match_expr_to_partition_keys(Expr *expr, RelOptInfo *rel)
+ {
+ 	int		cnt_pks;
+ 	int		num_pks;
+ 
+ 	/* This function should be called only for partitioned relations. */
+ 	Assert(rel->part_scheme);
+ 
+ 	num_pks = rel->part_scheme->partnatts;
+ 
+ 	/* Remove the relabel decoration. */
+ 	while (IsA(expr, RelabelType))
+ 		expr = (Expr *) (castNode(RelabelType, expr))->arg;
+ 
+ 	for (cnt_pks = 0; cnt_pks < num_pks; cnt_pks++)
+ 	{
+ 		List	 *pkexprs = rel->partexprs[cnt_pks];
+ 		ListCell *lc;
+ 
+ 		foreach(lc, pkexprs)
+ 		{
+ 			Expr *pkexpr = lfirst(lc);
+ 			if (equal(pkexpr, expr))
+ 				return cnt_pks;
+ 		}
+ 	}
+ 
+ 	return -1;
+ }
+ 
+ /*
+  * Calculate the bounds/lists of the join relation based on partition bounds of the
+  * joining relations. Also returns the matching partitions from the joining
+  * relations.
+  *
+  * As of now, it simply checks whether the bounds/lists of the joining
+  * relations match and returns bounds/lists of the first relation. In future
+  * this function will be expanded to merge the bounds/lists from the joining
+  * relations to produce the bounds/lists of the join relation. If the function
+  * fails to merge the bounds/lists, it returns NULL and the lists are also NIL.
+  *
+  * The function also returns two lists of RelOptInfos, one for each joining
+  * relation. The RelOptInfos at the same position in each of the lists give the
+  * partitions with matching bounds which can be joined to produce join relation
+  * corresponding to the merged partition bounds corresponding to that position.
+  * When there doesn't exist a matching partition on either side, corresponding
+  * RelOptInfo will be NULL.
+  */
+ static void
+ build_joinrel_partition_bounds(RelOptInfo *rel1, RelOptInfo *rel2,
+ 							   RelOptInfo *joinrel, JoinType jointype,
+ 							   List **rel1_parts, List **rel2_parts)
+ {
+ 	PartitionScheme	part_scheme;
+ 	int			cnt;
+ 	int			nparts;
+ 	int16	   *parttyplen;
+ 	bool	   *parttypbyval;
+ 
+ 	Assert(rel1->part_scheme == rel2->part_scheme);
+ 	Assert(rel1->nparts == rel2->nparts);
+ 	*rel1_parts = NIL;
+ 	*rel2_parts = NIL;
+ 
+ 	part_scheme = rel1->part_scheme;
+ 
+ 	/*
+ 	 * Ideally, we should be able to join two relations which have different
+ 	 * number of partitions as long as the bounds of partitions available on
+ 	 * both the sides match. But for now, we need exact same number of
+ 	 * partitions on both the sides.
+ 	 */
+ 	if (rel1->nparts != rel2->nparts)
+ 	{
+ 		/*
+ 		 * If this pair of joining relations did not have same number of
+ 		 * partitions no other pair can have same number of partitions.
+ 		 */
+ 		Assert(!joinrel->boundinfo && joinrel->nparts == 0);
+ 		return;
+ 	}
+ 
+ 
+ 	parttyplen = (int16 *) palloc(sizeof(int16) * part_scheme->partnatts);
+ 	parttypbyval = (bool *) palloc(sizeof(bool) * part_scheme->partnatts);
+ 	for (cnt = 0; cnt < part_scheme->partnatts; cnt++)
+ 		get_typlenbyval(part_scheme->partopcintype[cnt], &parttyplen[cnt],
+ 						&parttypbyval[cnt]);
+ 
+ 	if (!partition_bounds_equal(part_scheme->partnatts, parttyplen,
+ 								parttypbyval, rel1->boundinfo,
+ 								rel2->boundinfo))
+ 	{
+ 		/*
+ 		 * If this pair of joining relations did not have same partition bounds
+ 		 * no other pair can have same partition bounds.
+ 		 */
+ 		Assert(!joinrel->boundinfo && joinrel->nparts == 0);
+ 		return;
+ 	}
+ 
+ 	nparts = rel1->nparts;
+ 	for (cnt = 0; cnt < nparts; cnt++)
+ 	{
+ 		*rel1_parts = lappend(*rel1_parts, rel1->part_rels[cnt]);
+ 		*rel2_parts = lappend(*rel2_parts, rel2->part_rels[cnt]);
+ 	}
+ 
+ 	/* Set the partition bounds if not already set. */
+ 	if (!joinrel->boundinfo)
+ 	{
+ 		joinrel->boundinfo = rel1->boundinfo;
+ 		joinrel->nparts = rel1->nparts;
+ 	}
+ 	else
+ 	{
+ 		/* Verify existing bounds. */
+ 		Assert(partition_bounds_equal(part_scheme->partnatts, parttyplen,
+ 									  parttypbyval, joinrel->boundinfo,
+ 									  rel1->boundinfo));
+ 		Assert(joinrel->nparts == rel1->nparts);
+ 	}
+ 
+ 	pfree(parttyplen);
+ 	pfree(parttypbyval);
+ }
diff --git a/src/backend/optimizer/path/tidpath.c b/src/backend/optimizer/path/tidpath.c
new file mode 100644
index a2fe661..91d855c
*** a/src/backend/optimizer/path/tidpath.c
--- b/src/backend/optimizer/path/tidpath.c
*************** create_tidscan_paths(PlannerInfo *root,
*** 266,270 ****
  
  	if (tidquals)
  		add_path(rel, (Path *) create_tidscan_path(root, rel, tidquals,
! 												   required_outer));
  }
--- 266,270 ----
  
  	if (tidquals)
  		add_path(rel, (Path *) create_tidscan_path(root, rel, tidquals,
! 												   required_outer), false);
  }
diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
new file mode 100644
index 95e6eb7..3f1389f
*** a/src/backend/optimizer/plan/createplan.c
--- b/src/backend/optimizer/plan/createplan.c
*************** static Plan *prepare_sort_from_pathkeys(
*** 252,258 ****
  static EquivalenceMember *find_ec_member_for_tle(EquivalenceClass *ec,
  					   TargetEntry *tle,
  					   Relids relids);
! static Sort *make_sort_from_pathkeys(Plan *lefttree, List *pathkeys);
  static Sort *make_sort_from_groupcols(List *groupcls,
  						 AttrNumber *grpColIdx,
  						 Plan *lefttree);
--- 252,259 ----
  static EquivalenceMember *find_ec_member_for_tle(EquivalenceClass *ec,
  					   TargetEntry *tle,
  					   Relids relids);
! static Sort *make_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
! 									 Relids relids);
  static Sort *make_sort_from_groupcols(List *groupcls,
  						 AttrNumber *grpColIdx,
  						 Plan *lefttree);
*************** create_sort_plan(PlannerInfo *root, Sort
*** 1650,1656 ****
  	subplan = create_plan_recurse(root, best_path->subpath,
  								  flags | CP_SMALL_TLIST);
  
! 	plan = make_sort_from_pathkeys(subplan, best_path->path.pathkeys);
  
  	copy_generic_path_info(&plan->plan, (Path *) best_path);
  
--- 1651,1657 ----
  	subplan = create_plan_recurse(root, best_path->subpath,
  								  flags | CP_SMALL_TLIST);
  
! 	plan = make_sort_from_pathkeys(subplan, best_path->path.pathkeys, NULL);
  
  	copy_generic_path_info(&plan->plan, (Path *) best_path);
  
*************** create_mergejoin_plan(PlannerInfo *root,
*** 3767,3772 ****
--- 3768,3775 ----
  	ListCell   *lc;
  	ListCell   *lop;
  	ListCell   *lip;
+ 	Path	   *outer_path = best_path->jpath.outerjoinpath;
+ 	Path	   *inner_path = best_path->jpath.innerjoinpath;
  
  	/*
  	 * MergeJoin can project, so we don't have to demand exact tlists from the
*************** create_mergejoin_plan(PlannerInfo *root,
*** 3830,3837 ****
  	 */
  	if (best_path->outersortkeys)
  	{
  		Sort	   *sort = make_sort_from_pathkeys(outer_plan,
! 												   best_path->outersortkeys);
  
  		label_sort_with_costsize(root, sort, -1.0);
  		outer_plan = (Plan *) sort;
--- 3833,3842 ----
  	 */
  	if (best_path->outersortkeys)
  	{
+ 		Relids		outer_relids = outer_path->parent->relids;
  		Sort	   *sort = make_sort_from_pathkeys(outer_plan,
! 												   best_path->outersortkeys,
! 												   outer_relids);
  
  		label_sort_with_costsize(root, sort, -1.0);
  		outer_plan = (Plan *) sort;
*************** create_mergejoin_plan(PlannerInfo *root,
*** 3842,3849 ****
  
  	if (best_path->innersortkeys)
  	{
  		Sort	   *sort = make_sort_from_pathkeys(inner_plan,
! 												   best_path->innersortkeys);
  
  		label_sort_with_costsize(root, sort, -1.0);
  		inner_plan = (Plan *) sort;
--- 3847,3856 ----
  
  	if (best_path->innersortkeys)
  	{
+ 		Relids		inner_relids = inner_path->parent->relids;
  		Sort	   *sort = make_sort_from_pathkeys(inner_plan,
! 												   best_path->innersortkeys,
! 												   inner_relids);
  
  		label_sort_with_costsize(root, sort, -1.0);
  		inner_plan = (Plan *) sort;
*************** prepare_sort_from_pathkeys(Plan *lefttre
*** 5687,5697 ****
  					continue;
  
  				/*
! 				 * Ignore child members unless they match the rel being
  				 * sorted.
  				 */
  				if (em->em_is_child &&
! 					!bms_equal(em->em_relids, relids))
  					continue;
  
  				sortexpr = em->em_expr;
--- 5694,5704 ----
  					continue;
  
  				/*
! 				 * Ignore child members unless they belong to the rel being
  				 * sorted.
  				 */
  				if (em->em_is_child &&
! 					!bms_is_subset(em->em_relids, relids))
  					continue;
  
  				sortexpr = em->em_expr;
*************** find_ec_member_for_tle(EquivalenceClass
*** 5803,5812 ****
  			continue;
  
  		/*
! 		 * Ignore child members unless they match the rel being sorted.
  		 */
  		if (em->em_is_child &&
! 			!bms_equal(em->em_relids, relids))
  			continue;
  
  		/* Match if same expression (after stripping relabel) */
--- 5810,5819 ----
  			continue;
  
  		/*
! 		 * Ignore child members unless they belong to the rel being sorted.
  		 */
  		if (em->em_is_child &&
! 			!bms_is_subset(em->em_relids, relids))
  			continue;
  
  		/* Match if same expression (after stripping relabel) */
*************** find_ec_member_for_tle(EquivalenceClass
*** 5827,5835 ****
   *
   *	  'lefttree' is the node which yields input tuples
   *	  'pathkeys' is the list of pathkeys by which the result is to be sorted
   */
  static Sort *
! make_sort_from_pathkeys(Plan *lefttree, List *pathkeys)
  {
  	int			numsortkeys;
  	AttrNumber *sortColIdx;
--- 5834,5843 ----
   *
   *	  'lefttree' is the node which yields input tuples
   *	  'pathkeys' is the list of pathkeys by which the result is to be sorted
+  *	  'relids' is the set of relations required by prepare_sort_from_pathkeys()
   */
  static Sort *
! make_sort_from_pathkeys(Plan *lefttree, List *pathkeys, Relids relids)
  {
  	int			numsortkeys;
  	AttrNumber *sortColIdx;
*************** make_sort_from_pathkeys(Plan *lefttree,
*** 5839,5845 ****
  
  	/* Compute sort column info, and adjust lefttree as needed */
  	lefttree = prepare_sort_from_pathkeys(lefttree, pathkeys,
! 										  NULL,
  										  NULL,
  										  false,
  										  &numsortkeys,
--- 5847,5853 ----
  
  	/* Compute sort column info, and adjust lefttree as needed */
  	lefttree = prepare_sort_from_pathkeys(lefttree, pathkeys,
! 										  relids,
  										  NULL,
  										  false,
  										  &numsortkeys,
